#! /usr/bin/python
from OpenGL.GL import *
from OpenGL.GLUT import *
from OpenGL.GLU import *

window = 0  # window handler                                         
width, height = 480, 320 # window size
angle = 0

def tick(t):
    global angle
    angle += 1
    glutTimerFunc(100, tick, 0)
    glutPostRedisplay()
    
    
def draw():
    global angle
    # set transformation, projection and viewport
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT)
    glViewport(0, 0, width, height)
    glMatrixMode(GL_PROJECTION)
    glLoadIdentity()
    
    # now 0,0,0 is in the center    
    glOrtho(-width/2, width/2, -height/2, height/2, -100.0, 100.0)
        
    glMatrixMode (GL_MODELVIEW)
    glLoadIdentity()
 
    # this will compute rotation on transformation matrix
    glRotatef(angle, 1.0, 0.0, 0.0)
    glRotatef(2*angle, 1.0, 1.0, 0.0)
    
    # render (draw in 3D) something
    glColor3f(0.0, 0.0, 1.0)
    glutSolidTeapot(100)
    #glutWireTeapot(100)
    
    # show what was rendered in a buffer
    glutSwapBuffers() 
  


# --------------   program starts here   -----------------------

# initialize OpenGL by GLUT (openGl Utility Toolkit) library
glutInit()  
glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_ALPHA | GLUT_DEPTH)

# create window for graphiccs
glutInitWindowSize(width, height) 
glutInitWindowPosition(0, 0)
window = glutCreateWindow("IP&CG Lecture")

# this enables specified computations in openGl
glEnable(GL_DEPTH_TEST)
glEnable(GL_CULL_FACE)
glEnable(GL_LIGHTING)
glEnable(GL_NORMALIZE)
glEnable(GL_AUTO_NORMAL)

# defining light properties
ambientLight = [0.4, 0.4, 0.4, 1.0 ]
diffuseLight = [0.7, 0.7, 0.7, 1.0 ]
specular = [ 0.9, 0.9, 0.9, 1.0]
lightPos = [ -500.0, 2000.0, 2000.0, 1.0 ]
glLightModelfv(GL_LIGHT_MODEL_AMBIENT,ambientLight)
glLightfv(GL_LIGHT0,GL_AMBIENT,ambientLight)
glLightfv(GL_LIGHT0,GL_DIFFUSE,diffuseLight)
glLightfv(GL_LIGHT0,GL_SPECULAR,specular)
glLightfv(GL_LIGHT0,GL_POSITION,lightPos)
glEnable(GL_LIGHT0)

# specifies material properties
specref =  [ 0.6, 0.6, 0.6, 1.0 ]
glEnable(GL_COLOR_MATERIAL)
glColorMaterial(GL_FRONT, GL_AMBIENT_AND_DIFFUSE)
glMaterialfv(GL_FRONT, GL_SPECULAR,specref)
glMateriali(GL_FRONT,GL_SHININESS,64)

# set callback for drawing event
glutDisplayFunc(draw) 

# set timer callback function 
glutTimerFunc(100, tick, 0)

# start the main loop (wait for system evants)
glutMainLoop() 